package org.ylhealth.ym.springtest.controller;

import java.util.List;

import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.hibernate.SQLQuery;
import org.hibernate.transform.Transformers;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ylhealth.ym.springtest.entity.UserInfo;
import org.ylhealth.ym.springtest.service.TransactionTestService;

@RestController
public class TestController {
  @Inject private TransactionTestService userInfoService;
  private Logger logger = LoggerFactory.getLogger(getClass());

  @GetMapping("/Test1")
  public UserInfo test1() {
    return userInfoService.findUserInfo("aaa");
  }
  
  @GetMapping("/create")
  public UserInfo create() {
    UserInfo u = new UserInfo("aaa1", "小虫", "闲谈软体架构：休息时间");
    userInfoService.save(u);
    return u;
  }
  
  @GetMapping("/testTA")
  public String testTransaction() {
    userInfoService.testTransaction();
    return "結束";
  }
  @GetMapping("/testTA1")
  public String testTransaction3() {
    userInfoService.testTransaction3();
    return "結束2";
  }
  @GetMapping("/testTA2")
  public String testTransaction2() {
    logger.debug("testTransaction2 start");
    userInfoService.testTransaction1();
    userInfoService.testTransaction2();
    logger.debug("testTransaction2 end");
    return "結束3";
  }
  
  @Inject
  private EntityManager em;
  @GetMapping("/testQuery")
  public List testTransaction4() {
    return em.createNamedQuery("CrmSystemL1basic.test").getResultList();
  }
  @GetMapping("/testQuery1")
  public List testTransaction5() {
    Query query = em.createNamedQuery("CrmSystemL1basic.test1");
    query.unwrap(SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    return query.getResultList();
  }
}
